import es, threading, urllib2, string, os, string

info = es.AddonInfo() 
info.name     = "AutoUpdate" 
info.version  = "1.0" 
info.url      = "http://addons.eventscripts.com/addons/view/autoupdate" 
info.basename = "autoupdate" 
info.author   = "JoeyT2007"

__au_version = es.ServerVar("__au_version", 1.0, "The version of AutoUpdate you are running.")
__au_version.makepublic()

class CheckUpdates(threading.Thread):
    def __init__(self, __au_script_realname, __au_update_url = None):
        self.__au_script_name = None
        self.__au_script_realname = __au_script_realname
        self.__au_script_version = None
        self.__au_update_url = __au_update_url
        threading.Thread.__init__(self)

    def run(self):
        __au_script_path = es.getAddonPath(self.__au_script_realname) + "/" + self.__au_script_realname + ".py"
        if os.path.exists(__au_script_path):
            __au_script_file = open(__au_script_path, 'r')
            __au_info = None
            __au_stop = 0
            for __au_line in __au_script_file.readlines():
                if "es.AddonInfo()" in __au_line:
                    if __au_stop == 0:
                        __au_line = __au_line.replace("es.AddonInfo()", "")
                        __au_line = __au_line.replace("=", "")
                        __au_line = __au_line.replace(" ", "")
                        __au_line = __au_line.replace("	", "")
                        __au_line = __au_line.replace("\n", "")
                        __au_line = __au_line.replace("\r", "")
                        __au_info = __au_line
                        au_stop = 1
            __au_script_file.close()
            if __au_info != None:
                __au_script_file = open(__au_script_path, 'r')
                for __au_line in __au_script_file.readlines():
                    if __au_info + ".name" in __au_line:
                        __au_line = __au_line.replace("%s.name" % __au_info, "")
                        __au_line = __au_line.replace("=", "")
                        __au_line = __au_line.replace(" ", "")
                        __au_line = __au_line.replace("	", "")
                        __au_line = __au_line.replace("\n", "")
                        __au_line = __au_line.replace("\r", "")
                        __au_line = __au_line.replace('"', "")
                        __au_line = __au_line.replace("'", "")
                        self.__au_script_name = __au_line
                    if __au_info + ".version" in __au_line:
                        __au_line = __au_line.replace("%s.version" % __au_info, "")
                        __au_line = __au_line.replace("=", "")
                        __au_line = __au_line.replace(" ", "")
                        __au_line = __au_line.replace("	", "")
                        __au_line = __au_line.replace("\n", "")
                        __au_line = __au_line.replace("\r", "")
                        __au_line = __au_line.replace('"', "")
                        __au_line = __au_line.replace("'", "")
                        self.__au_script_version = __au_line
                    if self.__au_update_url == None:
                        if __au_info + ".basename" in __au_line:
                            __au_line = __au_line.replace("%s.basename" % __au_info, "")
                            __au_line = __au_line.replace("=", "")
                            __au_line = __au_line.replace(" ", "")
                            __au_line = __au_line.replace("	", "")
                            __au_line = __au_line.replace("\n", "")
                            __au_line = __au_line.replace("\r", "")
                            __au_line = __au_line.replace('"', "")
                            __au_line = __au_line.replace("'", "")
                            self.__au_update_url = "http://addons.eventscripts.com/addons/download/" + __au_line
                __au_script_file.close()
                if self.__au_script_name != None and self.__au_script_version != None and self.__au_update_url != None:
                    es.msg("#multi", "#green[%s]#default Checking for updates..." % self.__au_script_name)
                    __au_online_version = None
                    __au_online_version = urllib2.urlopen("http://addons.eventscripts.com/addons/chklatestver/%s" % self.__au_script_realname).read()           
                    if __au_online_version != None:
                        if self.__au_script_version != __au_online_version:
                            es.msg("#multi", "#green[%s]#default This server is running an old version of %s, auto-updating..." % (self.__au_script_name, self.__au_script_name))
                            __au_update_file = None
                            __au_update_file = urllib2.urlopen(self.__au_update_url).read()
                            if __au_update_file != None:
                                __au_script_path = es.getAddonPath(self.__au_script_realname) + "/" + self.__au_script_realname + ".py"
                                if os.path.exists(__au_script_path):
                                    __au_script_file = open(__au_script_path, 'w')
                                    __au_script_file.write(__au_update_file)
                                    __au_script_file.close()
                                    es.reload("%s" % self.__au_script_realname)
                                    es.msg("#multi", "#green[%s]#default Auto-update complete!" % self.__au_script_name)
                                else:
                                    es.msg("#multi", "#green[%s]#default Cannot install updates!" % self.__au_script_name)
                            else:
                                es.msg("#multi", "#green[%s]#default Cannot check for updates!" % self.__au_script_name)
                        else:
                            es.msg("#multi", "#green[%s]#default No new updates found!" % self.__au_script_name)
                    else:
                        es.msg("#multi", "#green[%s]#default Cannot check for updates!" % self.__au_script_name)
                else:
                    es.msg("#multi", "#green[%s]#default Cannot check for updates!" % self.__au_script_realname)
            else:
                es.msg("#multi", "#green[%s]#default Cannot check for updates!" % self.__au_script_realname)
        else:
            es.msg("#multi", "#green[%s]#default Cannot check for updates!" % self.__au_script_realname)